//Global variables
var headImage = null;

//headImage.crossOrigin = "anonymous";
var titleHeight = 0;
var eventHeight = 0;
var maxImageHeight = 150;
var maxImageWidth = 298;

//Constants for element x and y values
const xHeaderAdjustment = 2;
const yCardID = 47;
const yHeader = 32;
const xOps = 66;
const yOps = 80;
const yImage = 90;
const yRemoved = 488;
const titlePadding = 40;
const eventPadding = 4;
const titleLineHeight = 30;
const eventLineHeight = 24;

window.addEventListener("load", eventWindowLoaded, false);

function eventWindowLoaded() {
    //Get all the fonts to load I guess: 
    var c = document.getElementById("myCanvas"),  ctx = c.getContext("2d");
    ctx.font = "18px caslon-semibold-italic";
    ctx.fillText(" ",0,0)
    ctx.font = "18px caslon-bold";
    ctx.fillText(" ",0,0)
    ctx.font = "18px caslon-regular";
    ctx.fillText(" ",0,0)
    ctx.font = "18px caslon-italic";
    ctx.fillText(" ",0,0)
    doStuff(); //Run the code for drawing to the canvas.
}


function doStuff(){
    var c = document.getElementById("myCanvas"),  ctx = c.getContext("2d");
 
    ctx.fillStyle = "#E3F5FF";
    ctx.strokeStyle = "#E3F5FF";
    
    /* Source for rounded corners code: https://jsfiddle.net/robhawkes/ghcjt/ */
    
    // Set rectangle and corner values
    var rectX = 0;
    var rectY = 0;
    var rectWidth = 375;
    var rectHeight = 525;
    var cornerRadius = 54;

    // Set faux rounded corners
    ctx.lineJoin = "round";
    ctx.lineWidth = cornerRadius;

    // Change origin and dimensions to match true size (a stroke makes the shape a bit larger)
    ctx.strokeRect(rectX+(cornerRadius/2), rectY+(cornerRadius/2), rectWidth-cornerRadius, rectHeight-cornerRadius);
    ctx.fillRect(rectX+(cornerRadius/2), rectY+(cornerRadius/2), rectWidth-cornerRadius, rectHeight-cornerRadius);

    
    //Sets the initial text color and alignment
    ctx.fillStyle = "#211D1E";
    ctx.textAlign = "center";
    
    //Loads the user selected image and draws it
    //This also calls the header and text drawing functions
    loadImageFileAsURL(ctx , c);

    //COMMENT OUT WHEN RUNNING ON LOCAL MACHINE (TAINTED CANVAS)
    setTimeout(function(){
        var test = document.getElementById("downloadButton");
        var data = c.toDataURL();
        test.setAttribute('href', data);
    }, 500); 
}


//Function for preventing text spilling off the canvas
function wrapText(ctx, text, x, y, maxWidth, lineHeight, permanentBool) {
    var words = text.split(' ');
    var line = '';
    var numberOfLines = 1; //variable for working out overall text height.
    
    for(let n = 0; n < words.length; n++) {
        var testLine = line + words[n] + ' ';
        var metrics = ctx.measureText(testLine);
        var testWidth = metrics.width;

        //If the line were to be longer than the limit
        if (testWidth > maxWidth && n > 0) {
            line = line.trim();
            drawline(); //Draw the red underline if 'permanent' is selected
            ctx.fillText(line, x, y); //Write the line
            line = words[n] + ' ';
            y += lineHeight;        
            numberOfLines++; //Add 1 to the variable for working out text height
        }
        else {
            line = testLine;
        }
    }
    line = line.trim();
    drawline(); //Draw the red underline if 'permanent' is selected
    ctx.fillText(line, x, y); //Write the line
    return numberOfLines; //return the variable for working out text height
    
    //Draw a red line under the text=line before it overflows
    function drawline()
    {
        if (permanentBool == true)
            {
            metrics = ctx.measureText(line);
            let previousWidth = metrics.width;
            let start = x - (previousWidth / 2);
            ctx.beginPath();
            ctx.moveTo(start+1,y+4);
            ctx.lineTo(start+previousWidth-9,y+4);
            ctx.strokeStyle="#DE1C37";
            ctx.lineWidth=2;
            ctx.stroke(); 
            }
    }
}


//Draws the header
function drawheader(c , ctx) {
    
    headImage = document.createElement("img");
    
    var deck = document.getElementById("deck").value;
    var association = document.getElementById("association").value;
    
    //Sets the image based on the chosen deck and superpower association.
    if (deck == 0 && association == 0)
        { headImage.src = "templates/ewUSSR.png"; }
    else if (deck == 0 && association == 1)
        { headImage.src = "templates/ewUSA.png"; }
    else if (deck == 0 && association == 2)
        { headImage.src = "templates/ewNeutral.png"; }
    else if (deck == 1 && association == 0)
        { headImage.src = "templates/mwUSSR.png"; }
    else if (deck == 1 && association == 1)
        { headImage.src = "templates/mwUSA.png"; }
    else if (deck == 1 && association == 2)
        { headImage.src = "templates/mwNeutral.png"; }
    else if (deck == 2 && association == 0)
        { headImage.src = "templates/lwUSSR.png"; }
    else if (deck == 2 && association == 1)
        { headImage.src = "templates/lwUSA.png"; }
    else if (deck == 2 && association == 2)
        { headImage.src = "templates/lwNeutral.png"; }
    else 
        { headImage.src = "templates/error.png"; }
    
    //headImage.setAttribute('crossorigin', 'anonymous');
    //Makes sure the image has loaded before it tries to display it
    headImage.onload = function() 
        {
            //Centres the image
            var x = (c.width - headImage.width) / 2;
            ctx.drawImage(headImage, x - xHeaderAdjustment, yHeader);

            //Choose ops point color based on superpower association
            if (association == 0)
                {ctx.fillStyle = "#FFFFFF";}
            else
                {ctx.fillStyle = "#211D1E";}
        
            //Draws the OP points on top of the header
            ctx.font = "bold 32px sans-serif";
            var opsPoints = document.getElementById("opsPoints").value;
            ctx.fillText(opsPoints, xOps, yOps);
        }
}

//Handles the loading of the user selected image
function loadImageFileAsURL(ctx , c)
{
    var drawHeight = 0, drawWidth = 0;
    var filesSelected = document.getElementById("userfile").files;
    if (filesSelected.length > 0)
    {
        var fileToLoad = filesSelected[0];

        if (fileToLoad.type.match("image.*"))
        {
            var fileReader = new FileReader();
            fileReader.onload = function(fileLoadedEvent) 
            {
                var imageLoaded = document.createElement("img");
                imageLoaded.crossOrigin='anonymous';
                imageLoaded.src = fileLoadedEvent.target.result;
                imageLoaded.onload = function() 
                {
                    /*If the image loaded is larger the the maximum width or 
                    height then bring it within bounds and calculate the right ratio for the other axis*/
                    var imageHeight = imageLoaded.height;
                    var imageWidth = imageLoaded.width;
                    var imageRatio = 0.00;
                    
                    
                    
                    //If the image is larger than the max in either axis
                    if ((imageHeight > maxImageHeight) || (imageWidth > maxImageWidth))
                        {
                            //If height is bigger, then ratio is width/height
                            if (imageHeight >= imageWidth)
                                {
                                    imageRatio = imageWidth / imageHeight;
                                    drawHeight = maxImageHeight;
                                    drawWidth = drawHeight * imageRatio;
                                    //Handle resizing again if the width is now bigger than the limit
                                    //(Not needed if max height is less than max width)
                                    if (drawWidth >= maxImageWidth){
                                        let heightDifference = (drawWidth - maxImageWidth);
                                        drawWidth = maxImageWidth;
                                        drawHeight -= (heightDifference * (1 + imageRatio));
                                    }
                                }
                            //If width is bigger, then the ratio is height/width
                            else 
                                {
                                    imageRatio = imageHeight / imageWidth;
                                    drawWidth = maxImageWidth;
                                    drawHeight = drawWidth * imageRatio;
                                    //Handle resizing again if the height is now bigger than the limit
                                    //(Not needed if max width is less than max height)
                                    if (drawHeight >= maxImageHeight){
                                        let heightDifference = (drawHeight - maxImageHeight);
                                        drawHeight = maxImageHeight;
                                        drawWidth -= (heightDifference * (1 + imageRatio));
                                    }
                                }
                            
                        }   
                    
                    //If the image is within bounds then do nothing to it's size
                    else
                        {
                            drawHeight = imageHeight;
                            drawWidth = imageWidth;
                        }
                    
                    //x is a variable used to align the image in the centre
                    var x = (c.width - drawWidth) / 2;
                    
                    //Draw a border outside the picture if it is a photo
                    if (document.getElementById("imagephoto").checked == true)
                    {
                        ctx.beginPath();
                        ctx.rect(x, yImage, drawWidth, drawHeight);
                        ctx.lineWidth = 2;
                        ctx.strokeStyle = 'black';
                        ctx.stroke();
                    }
                   
                    //Draw the image
                    ctx.drawImage(imageLoaded, x, yImage, drawWidth, drawHeight);
                    
                    //Draws the header so it overlaps the image
                    drawheader(c , ctx);
                    
                    //Now we know the height of the image, we can draw the text under it
                    managetext (c , ctx , drawHeight);
                } 
            };
            fileReader.readAsDataURL(fileToLoad);
        }
    }
    
    //If no image was loaded
    else
    {
            //Draws the header
            drawheader(c , ctx);
                    
            //Draws the text
            managetext (c , ctx , drawHeight);
    }
}

//Draws text
function managetext (c, ctx, userImageHeight)
{
    //Sets variables for use in the wordwrap function
    var maxWidth = 305;
    var lineHeight;
    var x = (c.width) / 2;
    var y = 0;
    //variable for calculating the height of the previous text element
    var previousTextLines = 0;
    
    
    /*TITLE TEXT*/
    //Detecting if it is a permanent event and should be underlined
    var permanentBool = false;
    if (document.getElementById("permanent").checked == true)
        {
            permanentBool = true;
        }
    
    //Variables and settings for word-wrapping the title
    ctx.font = "28px caslon-bold";
    ctx.fillStyle = "#211D1E";
    var name = document.getElementById("title").value;
    name = name.toUpperCase();
    y = yImage + userImageHeight + titlePadding;
    lineHeight = titleLineHeight;
    
    //If the removed box has been ticked then add some text
    if ((document.getElementById("removed").checked == true)||(document.getElementById("permanent").checked == true))
        {
            name = name + "*"
            //Prints the title
            previousTextLines = wrapText(ctx, name, x, y, maxWidth, lineHeight, permanentBool);
            var removed = "Remove from play if used as an event."
            ctx.fillStyle = "#DE1C37";
            ctx.font = "19px caslon-semibold-italic";
            ctx.fillText(removed, x, yRemoved);
        }
    else
        {
            //Prints the title
            previousTextLines = wrapText(ctx, name, x, y, maxWidth, lineHeight, permanentBool);
        }
    
    //If there is no pre-event text then use the title line height, otherwise use the event lineheight.
    lineHeight = titleLineHeight;
    var previousLineHeight = titleLineHeight;
    /*PRE-EVENT*/ 
    if (document.getElementById("preText").value != "")
        {
            lineHeight = chooseLineSize(1);
            previousLineHeight = chooseLineSize(1);
            y += ((previousTextLines * titleLineHeight) + eventPadding);
            var preEvent = document.getElementById("preText").value;
            ctx.fillStyle = "#211D1E";
            //ctx.font = "18px caslon-italic";
            ctx.font = chooseFontSize('caslon-italic', 1);
            previousTextLines = wrapText(ctx, preEvent, x, y, maxWidth, lineHeight);
        }
    
    
    /*EVENT TEXT*/
    //Variables for the event text


    //Choose the line height depending on user selected font size;
    lineHeight = chooseLineSize(0);
    //Multiple the previous amount of lines by the appropriate line height, depending on if there was pre-event text
    y += (previousTextLines * previousLineHeight) + eventPadding;
    var event = document.getElementById("event").value;
    ctx.font = chooseFontSize('caslon-regular', 0);
    ctx.fillStyle = "#211D1E";
    permanentBool = false; //Events are not underlined
    //Word-wraps the event text
    previousTextLines = wrapText(ctx, event, x, y, maxWidth, lineHeight);
    
    
    /*EVENT TEXT2*/
    if (document.getElementById("event2").value != ""){
        y += (previousTextLines * lineHeight) + eventPadding;
        var event2 = document.getElementById("event2").value;
        previousTextLines = wrapText(ctx, event2, x, y, maxWidth, lineHeight);
    }
    

    /*EVENT TEXT3*/
    if (document.getElementById("event3").value != ""){
        y += (previousTextLines * lineHeight) + eventPadding;
        var event3 = document.getElementById("event3").value;
        previousTextLines = wrapText(ctx, event3, x, y, maxWidth, lineHeight);
    }
    

    /*CARD ID*/
    var cardid = document.getElementById("cardid").value;
    //If the optional box is ticked then add some text
    if (document.getElementById("optional").checked == true)
        {
            cardid = cardid + " - OPTIONAL"
        }
    ctx.font = "14px caslon-regular";
    ctx.fillText(cardid, x, yCardID);
    
    
    /*POST EVENT*/ 
    if (document.getElementById("postText").value != "")
        {
            y += (previousTextLines * lineHeight) + eventPadding;
            var postEvent = document.getElementById("postText").value;
            //var improves = "Improves effect of \"" + postEvent + "\" event.";
            //var improves = postEvent;
            ctx.fillStyle = "#211D1E";
            //ctx.font = "18px caslon-italic";
            ctx.font = chooseFontSize('caslon-italic', 1);
            lineHeight = chooseLineSize(1);
            //ctx.fillText(postEvent, x, y); //y was 455
            previousTextLines = wrapText(ctx, postEvent, x, y, maxWidth, eventLineHeight);
        }
    
}

//Sets the user selected font size
function chooseFontSize(font, offset){
    let userFontSize = document.getElementById("fontSize").value;
    let fontString = `${userFontSize - offset}px ${font}`;
    return fontString;
}

function chooseLineSize(offset){
    let userFontSize = parseInt(document.getElementById("fontSize").value);
    let lineSize = (userFontSize + 4) - offset;
    return lineSize;
}
/* function download(){
    var c = document.getElementById("myCanvas");
    var image = c.toDataURL("jpg/jpeg");//.replace("image/png", "image/octet-stream"); 
    image.crossOrigin = 'anonymous';
    window.location.href=image; // it will save locally
} */